<script lang="ts">
import Vue from 'vue';
import { getPageMetadata } from '../../common/meta';
import { NextStepAlt } from '../../components/common/index.vue';
import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful.js';
import {
  EditionComparison as CeOrEe,
  HeaderSection,
} from '~/components/ce-or-ee/index.vue';
import { FooterEditLinkMixin } from '~/mixins';
import { convertToCaseSensitiveLocale } from '~/common/util';

export default Vue.extend({
  components: {
    CeOrEe,
    HeaderSection,
    NextStepAlt,
  },
  mixins: [FooterEditLinkMixin],
  async asyncData({ i18n }) {
    try {
      const content = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': 'install/ce-or-ee',
        include: 10,
        locale: convertToCaseSensitiveLocale(i18n.locale),
      });

      const doc = content.items[0].fields.pageContent;
      const spaceId = content.items[0].sys.space.sys.id;
      const entryId = content.items[0].sys.id;
      const metadata = {
        title: content.items[0].fields.seoMetadata[0].fields.ogTitle,
        ...content.items[0].fields.seoMetadata[0].fields,
      };

      const [cmsHero, cmsCards] = doc;

      const header = {
        title: cmsHero.fields.header,
        subtitle: cmsHero.fields.text,
      };

      const cardArray = cmsCards.fields.card.map((item) => {
        return {
          title: item.fields.title,
          features: item.fields.description,
          recommended: item.fields.pills && item.fields.pills[0],
          button: item.fields.button,
          disclaimer: item.fields.column2Description,
        };
      });

      const editions = {
        cards: cardArray,
      };

      return { header, editions, metadata, spaceId, entryId };
    } catch (e) {
      throw new Error(e);
    }
  },
  head() {
    return getPageMetadata(
      (this as any).metadata,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
});
</script>

<template>
  <div>
    <SlpContainer>
      <HeaderSection :data="header" />
    </SlpContainer>
    <section>
      <CeOrEe :data="editions" />
    </section>
    <NextStepAlt />
  </div>
</template>
